import ClsService from './ClsService'
import axios from 'axios'
// let _bar =  1;
export default class ClsAppConfig {

  constructor() {

  }
  // static get bar() {return _bar;}
  // static set bar(value) { _bar = value; }

  static loadAppConfig() {
    var settings = require('../assets/AppConfig.json');
    settings.map(function(setting) {

      var tmpkey = setting.key;
      var tmpvalue = setting.value;

      Object.defineProperty(ClsAppConfig, tmpkey, {
        value: tmpvalue,
        writable: true,
        enumerable: true,
        configurable: true
      });

      var tmpFunction = null;
      if (tmpvalue.includes('#')) {
        tmpFunction = function(domainName, methodName, data, succes, error, serviceUrl = tmpvalue) {
          var tmpGetServiceUrl = ClsAppConfig.getParamInDomainName(serviceUrl, domainName) + methodName;
          ClsService.post(tmpGetServiceUrl, data, succes, error);
        };
      } else {
        tmpFunction = function(methodName, data, succes, error, serviceUrl = tmpvalue) {
          var tmpGetServiceUrl = serviceUrl + methodName;
          ClsService.post(tmpGetServiceUrl, data, succes, error);
        };
      }
      ClsService[tmpkey] = tmpFunction;
    });
  }

  static getParamInDomainName(pParamName, pDomainName) {
    var re = '#' + pDomainName.toLowerCase() + '#';
    var TmpResult = pParamName.split(re);
    if (TmpResult.length > 1)
      return TmpResult[1];
    else
      return null;
  }
}

ClsAppConfig.loadAppConfig();
