import ClsService from '../../../src/classes/ClsService'
import ClsAppConfig from '../../../src/classes/ClsAppConfig'
import Vue from 'vue'

export default class ClsLookup {
  constructor() {

  }
  static get AllCIs(){
    return this;
  }

  static getCI(ciName, domainName, succes) {

    var tmpCICacheName = domainName + '_' + ciName;
    var tmpfind = ClsLookup[tmpCICacheName];
    if (tmpfind === undefined) {
      ClsService.SrvCIService(domainName, 'GetCI', {
        "PCiName": ciName
      }, function(args) {
        ClsLookup[tmpCICacheName] = args.data;
        succes(args.data);
      }, function(error) {
        succes(error);
      });
    } else {
      succes(tmpfind);
    }
  }
}

window.getCITitle = (pgridId, pCIName, pDotName, pDomainName) => {
  var tmpcontrolName = "gridCombo_" + pgridId;
  var tmp = $("#" + tmpcontrolName);
  setTimeout(function() {
    ClsLookup.getCI(pDotName, pDomainName, function(data) {
      if (data != undefined) {
        var tmpFind = data.find(f => f.Id === pCIName);
        if (tmpFind)
          $("#" + tmpcontrolName).html(tmpFind.Title);
        else
          $("#" + tmpcontrolName).html('نامشخص');
      }
    });
  }, 0);
  return "<div  id='" + tmpcontrolName + "'> </div>"
};
